/*

   Test prg for WTMTFSFT (Writing To Multiple Text Files Simoultaneously; FT_F* way).

*/

#include <hmg.ch>
#include "WTMTFSFT.ch"

PROCEDURE Main()

   SET CENT ON
   SET DATE GERM
   
   DEFINE WINDOW frmW2MTFS ;
      AT 0,0 ;
		WIDTH 635 HEIGHT 500 ;
		TITLE 'Test Write to multiple file simoultaneously - FT_F* way' ; 
		MAIN 
		
      ON KEY ESCAPE ACTION ThisWindow.Release
      
      DEFINE MAIN MENU
		
         POPUP '&File'
            ITEM '&Test - Aliased'    NAME mitTestA ACTION DoTestAliased()    // Write by "aliased" cmmand          
            ITEM '&Test - Un-Aliased' NAME mitTestU ACTION DoTestUnAliased()    // Once select WA and then Write by "un-aliased" way
		    SEPARATOR
            ITEM 'E&xit'    ACTION ThisWindow.Release
         END POPUP
         
      END MENU		
      
   END WINDOW // frmW2MTFS

   CENTER   WINDOW frmW2MTFS
   ACTIVATE WINDOW frmW2MTFS

RETURN  // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.


PROCEDURE DoTestAliased()                 // Write by "aliased" cmmand          

   LOCAL cTableName := "EMPLOYE.DBF",;
         cListFName := "EMP_LIST.TXT",;
         cLogFName  := "LOG_" + DTOS( DATE() ) + STRTRAN( TIME(), ":", "" )  + ".TXT" 
         
   LOCAL nLogFile,;    // Serial Number of Log file ( like SELECT() in DBF management system ) 
         nLstFile,;    // Serial Number of List file 
         nErrorNo := 0
         
   LOCAL nLstLines  := 0,;
         nLogLines  := 0
         
   LOCAL nPageNo := 0
   
   * 
   * Open Output text file, assign a Text File Work Area Serial number to it 
   * 
   * This test prg doesn't check any error situaiton 
   * 
   * For to control errors, need modify WTMTFSFT's modules to produce error messages
   *
      
   IF lEraseUponOpen   
      IF FILE( cListFName )
         FERASE( cListFName )
      ENDIF
      IF FILE( cLogFName )
         FERASE( cLogFName )
      ENDIF      
   ENDIF lEraseUponOpen      
   
   nLogFile := OpenOTF( cLogFName )       // open a new Output Text File to write activity log  
   
   AOUT nLogFile, "LOG file for employe list" 
   AOUT nLogFile, "People who has work days less than a week" 
   AOUT nLogFile 
   AOUT nLogFile, "Beg at :", DTOS( DATE() ), TIME() 
   
   nLstFile := OpenOTF( cListFName )      // open a new Output Text File to write employe list       
   
   AOUT nLstFile, PADC( "EMPLOYE LIST", 80 )       
   AOUT nLstFile, DTOC( DATE() ), SPACE( 60 ), STR( ++nPageNo, 3 )
   AOUT nLstFile
   AOUT nLstFile, "EmpID Surname      Name         Tlf.        D.   Wage Hire  Date    Salary" 
   AOUT nLstFile, "----- ------------ ------------ ----------- -- ------ ---------- ----------"
   
   USE (cTableName)        // Open table
   
   WHILE .NOT. EOF()
      IF EMP_DAYS < 7
         AOUT nLogFile, STR( EMP_ID, 5) ,;
                             EMP_SNAM,;
                             EMP_NAME,;
                             TRANSFORM( EMP_DAYS, "99" ) 
         ++nLogLines                             
      ELSE
         AOUT nLstFile, STR( EMP_ID, 5) ,;
                             EMP_SNAM,;
                             EMP_NAME,;
                             EMP_TLF,;
                             TRANSFORM( EMP_DAYS, "99" ),;
                             TRANSFORM( EMP_WAGE, "999.99"),;
                             EMP_BDATE,;
                             TRANSFORM( EMP_SALARY, "999,999.99" )
         ++nLstLines                                
      ENDIF 
      SKIP
   ENDDO   
   
   
   AOUT nLogFile, "End at :", DTOS( DATE() ), TIME() 
   AOUT // nLogFile
   AOUT nLogFile, NTOC( nLogLines ), "lines recorded."
   
   AOUT nLstFile, "----- ------------ ------------ ----------- -- ------ ---------- ----------" 
   AOUT nLstFile
   AOUT nLstFile, STR( nLstLines, 5 ), "persons listed."

   CloseOTF( cLogFName )       
   CloseOTF( cListFName )      
   
   IF lShowUponClose
      IF FILE( cListFName )
         EXECUTE FILE "NOTEPAD.EXE" PARAMETERS cListFName
      ENDIF
      IF FILE( cLogFName )
         EXECUTE FILE "NOTEPAD.EXE" PARAMETERS cLogFName
      ENDIF      
   ENDIF
   
RETURN  // DoTestAliased()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE DoTestUnAliased()               // Once select WA and then Write by "un-aliased" way

   LOCAL cTableName := "EMPLOYE.DBF",;
         cListFName := "EMP_LIST2.TXT",;
         cLogFName  := "LOG2_" + DTOS( DATE() ) + STRTRAN( TIME(), ":", "" )  + ".TXT" 
         
   LOCAL nLogFile,;    // Serial Number of Log file ( like SELECT() in DBF management system ) 
         nLstFile,;    // Serial Number of List file 
         nErrorNo := 0
         
   LOCAL nLstLines  := 0,;
         nLogLines  := 0
         
   LOCAL nPageNo := 0
   
   * 
   * Open Output text file, assign a Text File Work Area Serial number to it 
   * 
   * This test prg doesn't check any error situaiton 
   * 
   * For to control errors, need modify WTMTFSFT's modules to produce error messages
   *
      
   IF lEraseUponOpen   
      IF FILE( cListFName )
         FERASE( cListFName )
      ENDIF
      IF FILE( cLogFName )
         FERASE( cLogFName )
      ENDIF      
   ENDIF lEraseUponOpen      
   
   nLogFile := OpenOTF( cLogFName )       // open a new Output Text File to write activity log  

   UOUT "LOG file for employe list"    
   UOUT "People who has work days less than a week" 
   UOUT 
   UOUT "Beg at :", DTOS( DATE() ), TIME() 
   
   nLstFile := OpenOTF( cListFName )      // open a new Output Text File to write employe list       
   
   UOUT PADC( "EMPLOYE LIST", 80 )       
   UOUT DTOC( DATE() ), SPACE( 60 ), STR( ++nPageNo, 3 )
   UOUT 
   UOUT "EmpID Surname      Name         Tlf.        D.   Wage Hire  Date    Salary" 
   UOUT "----- ------------ ------------ ----------- -- ------ ---------- ----------"
   
   USE (cTableName)        // Open table
   
   WHILE .NOT. EOF()
      IF EMP_DAYS < 7
         FT_FSELECT( nLogFile )   
         UOUT STR( EMP_ID, 5) ,;
              EMP_SNAM,;
              EMP_NAME,;
              TRANSFORM( EMP_DAYS, "99" ) 
         ++nLogLines                             
      ELSE
         FT_FSELECT( nLstFile )   
         UOUT STR( EMP_ID, 5) ,;
              EMP_SNAM,;
              EMP_NAME,;
              EMP_TLF,;
              TRANSFORM( EMP_DAYS, "99" ),;
              TRANSFORM( EMP_WAGE, "999.99"),;
              EMP_BDATE,;
              TRANSFORM( EMP_SALARY, "999,999.99" )
         ++nLstLines                                
      ENDIF 
      SKIP
   ENDDO   
   
   FT_FSELECT( nLogFile )   
   UOUT "End at :", DTOS( DATE() ), TIME() 
   UOUT 
   UOUT NTOC( nLogLines ), "lines recorded."
   
   FT_FSELECT( nLstFile )   
   UOUT "----- ------------ ------------ ----------- -- ------ ---------- ----------" 
   UOUT 
   UOUT STR( nLstLines, 5 ), "persons listed."

   CloseOTF( cLogFName )       
   CloseOTF( cListFName )      
   
   IF lShowUponClose
      IF FILE( cListFName )
         EXECUTE FILE "NOTEPAD.EXE" PARAMETERS cListFName
      ENDIF
      IF FILE( cLogFName )
         EXECUTE FILE "NOTEPAD.EXE" PARAMETERS cLogFName
      ENDIF      
   ENDIF
   
RETURN  // DoTestUnAliased()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
