/*

   Higher level interface modules for FT_F* functions for
   
   Writing To Multiple Text Files Simoultaneously; FT_F* way.

   2013 Oct.
   
   Esgici
   
*/

#include <hmg.ch>
#include "WTMTFSFT.ch"

FUNCTION OpenOTF( ;                       // Open an Output Text File 
                  cOutTFName ) 
   
   LOCAL nRVal,;
         nTFWArea,;
         nTFHandle,;
         lContinue := .T.
   
	IF ! EMPTY( cOutTFName )
   
      IF TYPE( "lConfirmFileOverwrite" ) # "U" .AND. ;
         lConfirmFileOverwrite
         IF FILE( cOutTFName )
            lContinue := MsgYesNo( cOutTFName + " file exist;" + CRLF + CRLF + ;
                                            "overwrite ? ", "Confirm file overwrite" )        
         ENDIF FILE( cOutTFName )
      ENDIF   
      
      IF lContinue
         HB_MemoWrit( cOutTFName, '' )
         IF FILE( cOutTFName )
            FT_FSELECT( 0 )                  // 1st available TF work area
            nTFWArea := FT_FSELECT()         // Serial number of this area
            nTFHandle  := FT_FUSE( cOutTFName )	  
    	      IF nTFHandle > 0                 // USE'ed successfully
               FT_FSELECT( nTFWArea )
               nRVal := nTFWArea
            ELSE   
               nRVal := -1                   // Couldn't USE'ed
    	      ENDIF nTFHandle > 0          
         ELSE   
            nRVal := 0  // specifed file not found
         ENDIF FILE( cOutTFName )
      ELSE  
         nRVal := -2 //  File exit and overwrite not confirmed
      ENDIF lContinue
   ELSE
      nRVal := -3 // No out file  specified
	ENDIF ! EMPTY( cOutTFName )
   
RETURN nRVal // OpenOTF() 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE WritLn2OTF( ... )               // Write a line to Output Text File ( "aliased" way  )

   LOCAL nPCount := PCOUNT(),;
         aParams := HB_APARAMS(),;
         nParNo  := 0
   
   LOCAL nTFWANo := 1,;      // Text File Work Area No
         aData := {},;
         x1Data 
   
   IF nPCount > 0      
      nTFWANo := aParams[ 1 ] 
      FOR nParNo := 2 TO nPCount          
         AADD( aData, aParams[ nParNo ]  )
      NEXT 
   ENDIF      
   
   FT_FSELECT( nTFWANo )   
   
   WritLn2OTFSA( aData  )                   
   
RETURN // WritLn2OTF

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE WritLn2OTFSA( aData )         // Write a line to Output Text File ( "un-aliased" way  )

   LOCAL nVCount := LEN( aData ),;
         nValNo  := 0,;
         cData   := ''         // String to write
 
   IF !EMPTY( aData )  
   
      FOR nValNo := 1 TO nVCount
         cData += HB_ValToStr( aData[ nValNo ] ) + ;
                       IF( nValNo < nVCount, ' ', '' ) 
      NEXT
   
   ENDIF nVCount > 0

   
   FT_FAPPEND()
   FT_FWRITELN( cData )    
   
RETURN // WritLn2OTFSA( 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE CloseOTF( nTFWAno )

   FT_FSELECT( nTFWANo )   
   FT_FUSE()
   
RETURN // CloseOTF()       

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

FUNCTION PList2Arr( ... )                 // Convert parameters to array

   LOCAL aParams := HB_APARAMS()
         
   LOCAL aRVal := {}
   
   AEVAL( aParams, { | x1 | AADD( aRVal, x1 ) } )
   
RETURN aRVal // PList2Arr()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
